#define BOODLES.H

#ifndef ACTOR.H
#include "actor.h"
#endif

#ifndef FACTOR.H
#include "factor.h"
#endif

#ifndef EVENT.H
#include "event.h"
#endif

#ifndef FEVENT.H
#include "fevent.h"
#endif


#define GRASS 0
#define WATER 2
#define MOUNTAINS 1
#define VALLEY 3

#define BOODLE 0
#define BOODLEWIZ 1
#define BOODLINO 2
#define UNSETBOODLEBLASTER 3
#define BOODLETTAH 4
#define GRUMJUG 5
#define GRUMKING 6
#define GRUMBUGGY 7
#define UNSETGRUMBOMB 8
#define DEAD 9
#define BOODLEBLASTER 10
#define GRUMBOMB 11
#define CURSOR 12
#define BROKEBUGGY 13
#define SAFEBOODLE 14

#define SETTINGGRUMBOMB 20
#define CARRIEDGRUMJUG 21

void load_boodle_icons(void);

class bombeat: public fevent
{
public:
  bombeat() {assign_fevent(3, ONEFACE);};
};

class boodblast: public fevent
{
public:
  boodblast() {assign_fevent(2, ONEFACE);}
};

class boodbop: public fevent
{
public:
  boodbop() {assign_fevent(0, ONEFACE);};
};

class grumbop: public fevent
{
public:
  grumbop() {assign_fevent(1, FOURFACE);};
};


class boodlepiece : public factor
{
public:
  char movesleft;
  boodlepiece * cargo, * cargo2;
  boodlepiece() {movesleft = 0; cargo = NULL; cargo2 = NULL;};
  void die(void);
  virtual void setmovement(void);
  virtual void move(byte direction);
  void advance(void);
  void grumwomp(animactor * thebomb);
  virtual void attack(boodlepiece * target);
  virtual void pick_up(void) = 0;
  virtual void drop(void);
};


class boodle : public boodlepiece
{
public:
  boodle() {assign_icon(BOODLE, ONEFACE);};
  boodle(int boodletype) {assign_icon(boodletype,ONEFACE);};
  virtual void setmovement(void);
  virtual void pick_up(void);
};

class boodlewiz : public boodle
{
public:
  boodlewiz() : boodle(BOODLEWIZ) {};
};

class boodlino : public boodle
{
public:
  boodlino() : boodle(BOODLINO) {};
  void move(byte direction);
  void attack(boodlepiece * target);
};

class boodleblaster : public boodle
{
public:
  boodleblaster() : boodle(UNSETBOODLEBLASTER) {};
  virtual void setmovement(void);
};


class boodlettah : public boodle
{
public:
  boodlettah() : boodle(BOODLETTAH) {};
};

class grumjug : public boodlepiece
{
public:
  grumjug() {assign_icon(GRUMJUG, TWOFACE);};
  virtual void setmovement(void);
  void move(byte direction);
  void attack(boodlepiece * target);
  void pick_up(void);
};

class grumking : public boodlepiece
{
public:
  grumking() {assign_icon(GRUMKING, ONEFACE);};
  virtual void setmovement(void);
  void pick_up(void) {};
};

class grumbuggy : public boodlepiece
{
public:
  grumbuggy() {assign_icon(GRUMBUGGY, TWOFACE);};
  virtual void setmovement(void);
  void move(byte direction);
  void pick_up(void);
  void drop(void);
};

class grumbomb : public boodlepiece
{
public:
  grumbomb() {assign_icon(UNSETGRUMBOMB, ONEFACE);};
  virtual void setmovement(void);
  void move(byte direction);
  void pick_up(void){};
};

